Subject: Re: powerpc: Add user-return-notifier support

From: Ananth N Mavinakayanahalli <[email-masked]>
Date: Wed, 2 Sep 2015 10:39:58 +0530

On Tue, Sep 01, 2015 at 10:29:12PM -0500, Scott Wood wrote:
> On Wed, 2015-09-02 at 08:07 +0530, Ananth N Mavinakayanahalli wrote:
> > On Tue, Sep 01, 2015 at 07:03:12PM -0500, Scott Wood wrote:
> > > On Tue, 2015-09-01 at 12:11 +0530, Ananth N Mavinakayanahalli wrote:
> > > > On Mon, Aug 31, 2015 at 08:35:17PM +1000, Michael Ellerman wrote:
> > > > > On Tue, 2015-25-08 at 05:41:10 UTC, Ananth N Mavinakayanahalli wrote:

...

> > > > We could certainly make this a generic config option.. but I am yet to
> > > > see a real usecase outside of the KVM thingy. We do use TIF_UPROBE for
> > > > something very similar, though that needs to fire much before the
> > > > outstanding signals get handled. The user-return notifier is the last
> > > > thing executed before return to userspace -- the two cannot be merged.
> > > > 
> > > > Ananth
> > > > 
> > > > PS: I am not sure having an 'ok' against the Documentation/features/ for
> > > > powerpc is a valid enough argument for this :-)
> > > 
> > > So how did you test this?  What platforms did you test it on?  What 
> > > hardware 
> > > support does it need?
> > 
> > Simple kernel module below... Its fairly evident from the patch that the
> > feature is a software only construct and no specific hardware support is
> > needed.
> 
> It's evident now that I'm aware of what the purpose is... It wasn't 100% 
> 
> clear before, at least from a quick glance, given that the explanation was 
> 
> "look at this hardware-specific KVM patch", whether there was an assumption 
> of something else going on -- and even things that are implemented in 
> software often work differently on book3s versus book3e, ppc32 versus ppc64, 
> etc.

I meant the infrastructure is agnostic of the underlying Power platform.
Sorry if I wasn't clear.

> Why is this selected by KVM on PPC if KVM on PPC doesn't use it?  What is the 
> user you're trying to enable?

I copied Paul and Gautham to get their thoughts on whether it is
something they could use on Power. At this time, apart from enabling the
feature, I do not have a specific usecase for it. We can park this patch
pending a real user on powerpc.

> Where is the "profiler" that Documentation/features/debug/user-ret-
> profiler/arch-support.txt hints at?

I guess profiler is a misnomer. Not sure why it was named that and not a
notifier.

Ananth